#include "libgccvb.h"
#include "icfont.h"

//#include "notes.h"     // Note constants by DanB
#include "su11sfx.h"   // Sound engine header
#include "su11sfx.c"   // Sound engine implementation
#include "sounddat.h"  // Actual sounds

#include "vbtestchar.h"
#include "vbtestmap.h"

#include "superflybgmap.h"
#include "superflybgchar.h"

#include "mantisbgmap.h"
#include "mantisbgchar.h"

#include "superflymap.h"
#include "superflychar.h"

#include "killipedemap.h"
#include "killipedechar.h"

#include "killipedebgmap.h"
#include "killipedebgchar.h"

#include "panzerbgmap.h"
#include "panzerbgchar.h"

#include "panzermap.h"
#include "panzerchar.h"

#include "titlescreenfgchar3.h"
#include "titlescreenfgmap3.h"
#include "titlescreenbgchar.h"
#include "titlescreenbgmap.h"

#include "logo3d3char.h"
#include "logo3d3map.h"

#include "titlescreen4char.h"
#include "titlescreen4map.h"
//#include "fighterschar.h"
//#include "fightersmap.h"

#include "wallpaper14map.h"
#include "wallpaper14char.h"

#include "creditsmap.h"
#include "creditschar.h"

//#include "giantcrawlpart1bmap.h"
//#include "giantcrawlpart1bchar.h"

#include "newgiantfinalmap.h"
#include "newgiantfinalchar.h"


#include "behemothmap67.h"
#include "behemothchar67.h"

//#include "giantcrawl2map.h"
//#include "giantcrawl2char.h"
//#include "giantcrawl3map.h"
//#include "giantcrawl3char.h"
//#include "giantcrawl4map.h"
//#include "giantcrawl4char.h"
//#include "giantcrawl5map.h"
//#include "giantcrawl5char.h"
//#include "giantcrawl6map.h"
//#include "giantcrawl6char.h"
//#include "giantcrawl7map.h"
//#include "giantcrawl7char.h"

//#include "giantjumppart1bmap.h"
//#include "giantjumppart1bchar.h"
//#include "giantjump2map.h"
//#include "giantjump2char.h"
//#include "giantjump3map.h"
//#include "giantjump3char.h"
//#include "giantjump4map.h"
//#include "giantjump4char.h"
//#include "giantjump5map.h"
//#include "giantjump5char.h"
//#include "giantjump6map.h"
//#include "giantjump6char.h"
//#include "giantjump7map.h"
//#include "giantjump7char.h"
//#include "giantjump8map.h"
//#include "giantjump8char.h"
//#include "giantjump9map.h"
//#include "giantjump9char.h"

//#include "giantpunchpart1bmap.h"
//#include "giantpunchpart1bchar.h"
//#include "giantpunch2map.h"
//#include "giantpunch2char.h"
//#include "giantpunch3map.h"
//#include "giantpunch3char.h"
//#include "giantpunch4map.h"
//#include "giantpunch4char.h"
//#include "giantpunch5map.h"
//#include "giantpunch5char.h"
//#include "giantpunch6map.h"
//#include "giantpunch6char.h"

#include "rumblebeebgmap3.h"
#include "rumblebeebgchar3.h"

//#include "giantfgmap6.h"
//#include "giantfgchar6.h"

#include "giantbgmap7.h"
#include "giantbgchar7.h"

#include "rumblebeemap.h"
#include "rumblebeechar.h"

#include "meleedybugmap.h"
#include "meleedybugchar.h"

#include "meleedybugbgmap.h"
#include "meleedybugbgchar.h"

#include "nothingtempchar.h"
#include "nothingtempmap.h"

#include "blankchar.h"
#include "blankmap.h"
#include "blank1char.h"
#include "blank1map.h"

#include "behemothbgmap2.h"
#include "behemothbgchar2.h"

#include "bananabothchar.h"
#include "bananabothmap.h"
//#include "bananarightchar.h"
//#include "bananarightmap.h"

//#include "kaboomleftmap.h"
//#include "kaboomleftchar.h"
//#include "kaboomrightmap.h"
//#include "kaboomrightchar.h"

#include "grassbladeschar.h"
#include "grassbladesmap.h"

#include "mantismap.h"
#include "mantischar.h"	

int flipheight=37, opponentleft=0;
int frogwait=0, frogtimer=0, frogxsight=512, frogy=160, frogup=1, frogxcut=0, frogjumptimer=0;
unsigned int FramesUntilNextSound = 0;  // For demonstration purposes only.
char animframe=0, animframe2=1, animframe3=8, animwait=0;
int opponentmovedir=1, opponentxsight=30, difference=0, differenceminus=0, fighterxsight=0;
int fighterpos1x=0, fighterpos1y=0, fighterpos2x=0, fighterpos2y=0, fighterpos3x=0, fighterpos3y=208;
int cursorx=80, cursory=43, fighterx=173, fightery=156, attackopponentx=0, attackopponentxminus=0;
char fighter=1, opponent=1, scrolltimer=0, paused=0;
//int currNoteLength=600, l=0, m=0, n=0, o=0, r=0, jumpjumptimer=0;
int opponentx=160, opponenty=156, e=0, left2=0;
int opponentxplus=0, opponentyminus=0, opponentyplus=0, sound=0, opponentxminus=0, sfxmake=0;
unsigned char StartGame=4, MusicOver=0, GoingToMain=0, fight=0;
unsigned char CreditsCheat=0, ButtonCredits=0, CreditsScrollingTimer=0, Credits=0;
unsigned char scrolltimer2=0, fighterx2=0, logoy=182, logotimer=0;
unsigned char flipping=0, w1=22, w2=20, count=1, turning=0, left=0, right=0, bugicony=25, select=0, openingpart=1;
int bgscroll=20, CreditsScrollingY=224, CreditsScrollingY2=448;
unsigned char bgbgscrolltimer=0, whichchar;
int bgbgscroll=0, bgtopscroll=0, neg=-1, neg2=1, GoToStart=0, bgmovey=0, bgmovex=0;
unsigned char Intro=1, r=0, l=0, opponentflip=0, GetRidofIcky;
unsigned char punchtimer=0, punchtimer2=0, CreditsTimer=0, changeback=0, howmanyflip=13, fliptheh;
u16 freq;
int punch=0, special=0, specialtimer=0;
//int i[4]=1;

int opponentcharcutouty, charcutouty, chartotaly, opponentchartotaly;
int grassbladestartx=0, grassbladestarty=0, grassbladetotalx=52, grassbladetotaly=52;
int grassframe=0, grasstimer=0, groundy=180, grassy=180;
int ani_objects=1, jumptimer2=0, falltimer2=0, charcutouty2=0, charcutoutx=0, charcutoutx2=0, totalx1=0, totalx2=0;

u32 SongTick;
u32 SongTick2;
u8 currNote;	
u8 currBassNote;	
u8 instrument1=2, instrument2=1, instrument3=1, whichmap;

u16 freq;
u8 vol;
u8 chan=0;

//scrolling variables for the old version ("Insect Combat") in case I decide to go back to it.
//int scroll=-192, scrolly=0;
//int scroll2=112, scroll2y=-16;

//int scroll3=-192, scroll3y=224;
//int scroll4=112, scroll4y=208;

int scroll=-192, scrolly=0;
int scroll2=112, scroll2y=-16;
int scroll3=-192, scroll3y=224;
int scroll4=112, scroll4y=208;
int currSong=1;
int TitleScreenSong=0, currlowernote=0;
int jump=0, fall=0, jumptimer=0, falltimer=0, moverand=0, oppdir=0, movetimer=0, movestop=0, movetimer2=0, moverand2=3;
char startY=0, thingtoflip=15;

//#define SSTOP            *(u8*)0x01000580 //Sound Stop: 0x01 = Stop (all other bits ignored)

void instrumentchange(){
switch(instrument1)
	{
		case 1:
		copymem((void*)WAVEDATA1, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA1, (void*)PIANO, 128);
		break;
	
		case 3:
		copymem((void*)WAVEDATA1, (void*)VIOLIN, 128);
		break;
		
		default:
		break;		
		}
		
	switch(instrument2)
	{
		case 1:
		copymem((void*)WAVEDATA2, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA2, (void*)PIANO, 128);
		break;
		
		case 3:
		copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);
		break;
		
		default:
		break;
		}		

	switch(instrument3)
	{
		case 1:
		copymem((void*)WAVEDATA3, (void*)SINE, 128);
		break;
		
		case 2:
		copymem((void*)WAVEDATA3, (void*)PIANO, 128);
		break;
		
		case 3:
		copymem((void*)WAVEDATA3, (void*)VIOLIN, 128);
		break;
		
		default:
		break;		
		}	
}


void HFlip(char bgmap) {
  char y;
  char startX=39;
  char startY=0;
  char width=13;
  char height=flipheight;
  
  
  for (y=0; y<height; y++, startY++) {
    HWORD* leftCell = &BGMM[bgmap*(0x1000) + (startY * 64) + startX];
    HWORD* rightCell = leftCell + width - 1;
    while (leftCell <= rightCell) {
      HWORD tmpCell = *rightCell;
      *rightCell = *leftCell ^ 0x2000;
      *leftCell = tmpCell ^ 0x2000;
      leftCell++;
      rightCell--;
    }
  }
  
  }
  
void HFlip2(char bgmap) {
  char y;
  char startX=0;
  char startY=0;
  char width=39;
  char height=37;
  
  
  for (y=0; y<height; y++, startY++) {
    HWORD* leftCell = &BGMM[bgmap*(0x1000) + (startY * 64) + startX];
    HWORD* rightCell = leftCell + width - 1;
    while (leftCell <= rightCell) {
      HWORD tmpCell = *rightCell;
      *rightCell = *leftCell ^ 0x2000;
      *leftCell = tmpCell ^ 0x2000;
      leftCell++;
      rightCell--;
    }
  }
  
  
}


void ChangeCharsegOfBGMap(BYTE bgmap, BYTE chseg) { 
  HWORD j; 
   
  for (j=0; j<4096; j++) { 
    HWORD* currCell = &BGMM[bgmap*(0x1000) + j]; 
    *currCell &= 0xF9FF;
    *currCell |= (chseg << 9);
  } 
}

int main()

	{

	opponent=0, fighter=0;
	VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up
	while (!(VIP_REGS[XPSTTS] & XPBSY1)); // makes sure to freeze screen on framebuffer 0
	VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] & ~XPEN; // turn off screen refreshing so once a dot is drawn it stays there until refreshed again (start pressed)		

	jump=0, jumptimer=0, fall=0, falltimer=0;
	GetRidofIcky=0;
	specialtimer=0, special=0;

	copymem((void*)CharSeg0, (void*)BLANKCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)BLANKMAP, 512*16);	

	
	

	frogwait=0, frogtimer=0, frogxsight=400, frogy=140, frogup=1, frogxcut=0, frogjumptimer=64;
	copymem((void*)CharSeg3, (void*)ICFONT, 8192);
	
	copymem((void*)WAVEDATA1, (void*)SINE, 128);

	vbSetWorld(31, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(30, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);  
	vbSetWorld(27, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(20, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(19, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(18, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(20, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	//vbSetWorld(19, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);
	//	

	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// front
	vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back
	vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	     // body

	vbSetWorld(14, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(15, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(16, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(11, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// front
	vbSetWorld(13, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back
	vbSetWorld(12, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	     // body


	
	opponentflip=1;
	

	
	
	
	// while (vbReadPad()==0) { 
	// randomPointer++; 
	// } 
	// randomPointer %= 4; 

	vbDisplayOn();
	vbDisplayShow();


    if ((GoToStart==0) && (StartGame>2))
	{	
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);	
		vbTextOut(0, 20, 10,"IMPORTANT:");
		vbTextOut(0, 14, 12,"SCREW THE INSTRUCTION");
		vbTextOut(0, 13, 14,"AND PRECAUTION BOOKLETS");
		vbTextOut(0, 15, 16,"JUST PLAY THE GAME.");
	}



	while((GoToStart==0) && (StartGame>3)){
	

	if((vbReadPad()&K_STA) && (StartGame==4)) StartGame=6;
	if((!(vbReadPad()&K_STA)) && (StartGame==6)) StartGame=3;
	
	}
	
	
	if ((GoToStart==0) && (StartGame>2))
		{copymem((void*)CharSeg1, (void*)VBTESTCHAR, 256*16);
		copymem((void*)BGMap(1), (void*)VBTESTMAP, 512*16);
	}
	while ((GoToStart==0) && (StartGame>2)){


  
	vbSetWorld(31, WRLD_LON|1, 0, 0, 0, 0, 0, 0, 384, 224);
    vbSetWorld(30, WRLD_RON|1, 0, 0, 0, 0, 0, 224, 384, 224);


	if((vbReadPad()&K_STA) && (StartGame==3)) StartGame=4;
	if((!(vbReadPad()&K_STA)) && (StartGame==4)) StartGame=1;
	

	
	}
	if ((GoToStart==0) && (StartGame==1)){
	copymem((void*)CharSeg1, (void*)BANANABOTHCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)BANANABOTHMAP, 512*16);	

	
	
	
	
	}	

	while((GoToStart==0) && (StartGame<2)){		


	vbSetWorld(30, WRLD_RON|1, 40, 0, 20, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_LON|1, 40, 0, 20, 0, 0, 224, 384, 224);	
	vbSetWorld(29, WRLD_ON, 40, 0, 20, 0, 0, 0, 384, 18);	
	
	vbTextOut(0, 20, 1,"BANANA PRESENTS");
	

	
	
	if((vbReadPad()&K_STA) && (StartGame==1)) StartGame=0;
	if((!(vbReadPad()&K_STA)) && (StartGame==0)) StartGame=3;	
	

	
	//if((vbReadPad()&K_STA) && (StartGame==2)) StartGame=1;
	//if((!(vbReadPad()&K_STA)) && (StartGame==1)) StartGame=3;	
	
	}
	

	

	
	InitSound();
	
	
	
	Intro=0;
	if ((GoToStart==0) && (StartGame>2)) Intro=1;
		
	
	
	if ((GoToStart==0) && (Intro==1)) {
	
	copymem((void*)CharSeg0, (void*)BLANKCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)BLANKMAP, 512*16);		
	//copymem((void*)CharSeg2, (void*)KABOOMRIGHTCHAR, 512*16);
	//copymem((void*)BGMap(2), (void*)KABOOMRIGHTMAP, 512*16);	
	//copymem((void*)CharSeg1, (void*)KABOOMLEFTCHAR, 512*16);
	//copymem((void*)BGMap(1), (void*)KABOOMLEFTMAP, 512*16);		
	//vbSetWorld(31, WRLD_LON|2, 0, 2, 0, 0, 0, 0, 384, 224);
	//vbSetWorld(30, WRLD_RON|1, 0, -2, 0, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(29, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);	
	

	
	}
	

	
	
	//instrumentchange();
	
	while((GoToStart==0) && (Intro==1))
	{
	

	//copymem((void*)WAVEDATA1, (void*)SINE, 128);	
	//copymem((void*)WAVEDATA2, (void*)SINE, 128);	
	//copymem((void*)WAVEDATA3, (void*)SINE, 128);	
	


	



	
	
	vbSetWorld(29, WRLD_ON, 0, -2, CreditsScrollingY, 0, 0, 0, 384, 224);		
	//vbSetWorld(28, WRLD_ON|3, 0, -2, CreditsScrollingY2, 0, 0, 0, 384, 224);		
	
	CreditsTimer++;
    if ((CreditsTimer>7)) CreditsTimer=0, CreditsScrollingY--;
	if (CreditsScrollingY<-222) openingpart++, CreditsScrollingY=222;
	if ((CreditsScrollingY==-222) && (CreditsTimer>7)) CreditsScrollingY=224, CreditsTimer=0;
	if (openingpart==3) paused=-1;
	//if (CreditsScrollingY2==-194) paused=-1;
	
	if (openingpart==1){
	vbTextOut(0, 16, 7,"THE YEAR IS 2047.");
	vbTextOut(0, 16, 9,"MANKIND HAS ENDED");
	vbTextOut(0, 16, 11,"BECAUSE THEY BLEW");
	vbTextOut(0, 16, 13,"  THEMSELVES UP  ");
	vbTextOut(0, 16, 15,"LEAVING ONLY BUGS");
	vbTextOut(0, 16, 17,"     BEHIND.     ");
	}
	
	if (openingpart==2){
	vbTextOut(0, 16, 7,"NOW LIFE ON EARTH");
	vbTextOut(0, 16, 9," DEPENDS ON THE  ");
	vbTextOut(0, 16, 11," SURVIVAL OF THE ");
	vbTextOut(0, 16, 13," FITTEST. DO YOU ");
	vbTextOut(0, 16, 15,"   HAVE WHAT IT  ");
	vbTextOut(0, 16, 17,"TAKES TO SURVIVE?");	
	}
	
	DoSounds();
	PlaySound(intromusic);		
	
	if ((vbReadPad()&K_STA) && (paused==0)) paused=-1;
	if ((!(vbReadPad()&K_STA)) && (paused==-1)) Intro=2;	
	
		StartGame=5;	
	
	}
	
	
	paused=0;
	


	
	
	
	StopAllSounds();
	
	grassbladestartx=0, grassbladestarty=0, grassbladetotalx=52, grassbladetotaly=52;
	grassframe=0, grasstimer=0, groundy=188, grassy=174;

	vbTextOut(3, 16, 7,"                 ");
	vbTextOut(3, 16, 9,"                 ");
	vbTextOut(3, 16, 11,"                 ");
	vbTextOut(3, 16, 13,"                 ");
	vbTextOut(3, 16, 15,"                 ");
	vbTextOut(3, 16, 17,"                 ");
	
	//copymem((void*)WAVEDATA1, (void*)SAWTOOTH, 128); 	
	fight=0;
	
	//copymem((void*)CharSeg3, (void*)ICFONT, 8192);
	//instrument1=1, instrument2=1;
	
	copymem((void*)WAVEDATA1, (void*)SINE, 128);	
	copymem((void*)WAVEDATA2, (void*)SINE, 128);	
	
	
	copymem((void*)CharSeg2, (void*)GRASSBLADESCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)GRASSBLADESMAP, 512*16);		
	
	copymem((void*)CharSeg0, (void*)BLANKCHAR, 512*16);  
	copymem((void*)BGMap(0), (void*)BLANKMAP, 512*16); 	
	
	//copymem((void*)CharSeg2, (void*)TITLESCREENFGCHAR3, 512*16);
	//copymem((void*)BGMap(2), (void*)TITLESCREENFGMAP3, 512*16);		
	
	copymem((void*)CharSeg1, (void*)LOGO3D3CHAR, 512*16);  
	copymem((void*)BGMap(1), (void*)LOGO3D3MAP, 512*16);   
	
	//copymem((void*)CharSeg1, (void*)TITLESCREENBGCHAR, 256*16);
	//copymem((void*)BGMap(1), (void*)TITLESCREENBGMAP, 256*16);	
	
	if((vbReadPad()&K_STA) && (StartGame==5)) StartGame=4;
	if((!(vbReadPad()&K_STA)) && (bugicony==25) && (StartGame=4)) CreditsCheat=2;
	if((!(vbReadPad()&K_STA)) && (bugicony==26) && (StartGame=4)) Credits=0, CreditsCheat=4, CreditsScrollingY=0;		
	
	fighterx=122, fightery=62;
	bugicony=25, select=0;

	
	
	while(StartGame>2){
	
	



	if ((logoy>102) && (grassframe<18)) grasstimer++;
	if ((grasstimer>40) && (grassframe<18)) groundy++, grassy=grassy-2, grassframe++;
	if (grassframe>13) grasstimer=0;

	if ((grassframe<7) && (grasstimer>40)) grasstimer=0, grassbladestartx=grassbladestartx+52;
	
	
	if ((grassframe==7) && (grasstimer>40)) grasstimer=0, grassbladetotaly=104, grassbladetotalx=104, grassbladestartx=0, grassbladestarty=55;

	
	if ((grassframe>7) && (grasstimer<12) && (grasstimer>40)) grasstimer=0, grassbladetotaly=104, grassbladetotalx=104, grassbladestartx=grassbladestartx+104;


	if ((grassframe==12) && (grasstimer>40)) grasstimer=0, grassbladetotaly=104, grassbladetotalx=104, grassbladestartx=0, grassbladestarty=157;

	if ((grassframe==15) && (grasstimer>40)) grasstimer=0, grassbladetotaly=156, grassbladetotalx=166, grassbladestartx=0, grassbladestarty=260;

	if ((grassframe>15) && (grasstimer<18) && (grasstimer>40)) grassbladestartx=grassbladestartx+166;



	if (logotimer>3) logotimer=0, logoy--;
	if (logoy>102) logotimer++;
	
	DoSounds();
	

	if (logoy==102) {
	grassframe=18;
	PlaySound(song);
	PlaySound(songbass);
	//PlaySound(songcountermelody);
	
	
	
	}
		

	
    //SND_REGS[2].SxINT = 0x00;
    //SND_REGS[3].SxINT = 0x00;


		

 
   // SND_REGS[0].SxLRV = 0x66;

	VIP_REGS[GPLT0]=0x24; 
	VIP_REGS[GPLT1]=0xe4;
	//VIP_REGS[GPLT2]=0x00;
	
	vbTextOut(3, 0, 0,"                                                          ");
	vbTextOut(3, 0, 1,"                                                          ");
	//vbTextOut(3, 1, 26,"                    ");
	
	//if (logoy==102) {
	if (logoy==102) vbSetWorld(21, WRLD_ON|3, 0, 0, 8, 0, 0, 0, 384, 224);		// text
 
	vbTextOut(3, 20, 25,"PRESS START  ");	
	//vbTextOut(3, 20, 26,"VIEW CREDITS");
	
	if((vbReadPad()&K_SEL) && (logoy==102) && (select==0)) select=1;
	if((!(vbReadPad()&K_SEL) && (logoy==102) && (select==1))) select=0, bugicony++;

	if((vbReadPad()&K_STA) && (logoy==102)) StartGame=6;
	if((!(vbReadPad()&K_STA)) && (logoy==102) && (bugicony==25) && (StartGame==6)) StartGame=2, CreditsCheat=2;
	if((!(vbReadPad()&K_STA)) && (logoy==102) && (bugicony==26) && (StartGame==6)) StartGame=2, CreditsCheat=4, Credits=0, CreditsScrollingY=0;		
	
	if (bugicony==27) bugicony=25;	
	

	
	//}


	//vbSetWorld(21, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(29, WRLD_ON|1, 0, -2, groundy, 0, 0, 141, 384, 40);
	vbSetWorld(28, WRLD_ON|1, 0, -2, 0, 0, 0, 32, 384, 92);
	vbSetWorld(27, WRLD_ON|2, 0, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);	
	vbSetWorld(26, WRLD_ON|2, 64, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);	
	vbSetWorld(25, WRLD_ON|2, 128, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);	
	vbSetWorld(24, WRLD_ON|2, 196, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);	
	vbSetWorld(23, WRLD_ON|2, 256, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);
	vbSetWorld(22, WRLD_ON|2, 320, 2, grassy, grassbladestartx, 0, grassbladestarty, grassbladetotalx, grassbladetotaly);	
	
	vbSetWorld(30, WRLD_LON|1, 120, 0, logoy, 0, 0, 0, 179, 31);	
	vbSetWorld(31, WRLD_RON|1, 112, 0, logoy, 0, 0, 0, 179, 31);
	
	
	

	//octoy, xbeginning, ?, ybeginning, totalx, totaly

	




	
	//if (currNote<9) PlayNote(1, song13[0], 8);
	//if ((currNote>8) && (currNote<17)) PlayNote(1, song13[1], 8);
	//if (currNote>16) PlayNote(1, song13[2], 8);



	}



	vbTextOut(3, 19, 25,"             ");	
	vbTextOut(3, 19, 26,"             ");		

	//VIP_REGS[GPLT2]=0x08;
	//VIP_REGS[GPLT1]=0x24;


	StopAllSounds();
	CreditsScrollingY=0;	
	
	while(CreditsCheat>3){

	VIP_REGS[GPLT0]=0xe4; 

	copymem((void*)CharSeg1, (void*)CREDITSCHAR, 256*16);
	copymem((void*)BGMap(1), (void*)CREDITSMAP, 256*16);	
	
	//vbSetWorld(31, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);

	vbSetWorld(29, WRLD_ON|1, 0, -2, groundy, 0, 0, 141, 0, 0);
	vbSetWorld(28, WRLD_ON|1, 0, -2, 0, 0, 0, 32, 0, 0);
	vbSetWorld(27, WRLD_ON|2, 0, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);	
	vbSetWorld(26, WRLD_ON|2, 64, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);	
	vbSetWorld(25, WRLD_ON|2, 128, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);	
	vbSetWorld(24, WRLD_ON|2, 196, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);	
	vbSetWorld(23, WRLD_ON|2, 256, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);
	vbSetWorld(22, WRLD_ON|2, 320, 2, grassy, grassbladestartx, 0, grassbladestarty, 0, 0);	

	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON, 0, -2, CreditsScrollingY, 0, 0, 0, 384, 224);		
	
    CreditsScrollingY--;
	if (CreditsScrollingY<-224) Credits++, CreditsScrollingY=0;

	if (Credits==0) vbTextOut(0, 1, 26,"PROGRAMMED BY CHRIS READ    ");
	if (Credits==1) vbTextOut(0, 1, 26,"SPRITE ART BY CHRIS READ    "); 
	if (Credits==2) vbTextOut(0, 1, 26,"MUSIC BY CHRIS READ         ");
	if (Credits==3) vbTextOut(0, 1, 26,"GAME DESIGN BY CHRIS READ   ");
	if (Credits==4) vbTextOut(0, 1, 26,"SPECIAL THANKS TO PVB FORUMS");
	if (Credits==5) CreditsCheat=3;
	}	

	if (Credits==5) grassbladestartx=0, grassbladestarty=0, grassbladetotalx=52, grassbladetotaly=52;
	if (Credits==5) grassframe=0, grasstimer=0, groundy=188, grassy=174, logoy=182;
	if (Credits==5) Credits=0, StartGame=2, GoToStart=1, Intro=2, main();


	fighter=1; // change to 1 when completed.
	instrument1=0, instrument2=0, instrument3=0;





	//VIP_REGS[GPLT2]=0xF7;
	
	vbSetWorld(24, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);			

	vbSetWorld(21, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(25, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	

	vbSetWorld(27, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(26, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	

	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		

	//vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);

    vbTextOut(0, 20, 11,"          ");
    vbTextOut(0, 14, 12,"                     ");
    vbTextOut(0, 13, 13,"                       ");
    vbTextOut(0, 15, 14,"                   ");
	vbTextOut(3, 19, 25,"            ");
	vbTextOut(3, 19, 26,"            ");
	vbTextOut(3, 1, 0,"                      ");	
	vbTextOut(3, 22, 0,"      ");
	vbTextOut(3, 31, 0,"                     ");
	vbTextOut(3, 31, 1,"                     ");	

	copymem((void*)CharSeg1, (void*)WALLPAPER14CHAR, 512*16);
	copymem((void*)BGMap(1), (void*)WALLPAPER14MAP, 512*16);

	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	

  	//copymem((void*)CharSeg0, (void*)BLANKCHAR, 256*16);
	//copymem((void*)BGMap(0), (void*)BLANKMAP, 256*16);		
	
	StartGame=0, GoToStart=2;




	l=0, r=0, fighterxsight=140;

	while(StartGame<2){
	

    //SND_REGS[2].SxINT = 0x00;
    //SND_REGS[3].SxINT = 0x00;
	
	scrolltimer=scrolltimer+1;

	vbSetWorld(25, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	vbSetWorld(24, WRLD_ON, 0, 0, 0, 0, 0, 0, 0, 0);


	VIP_REGS[GPLT0]=0x24;
	VIP_REGS[GPLT1]=0x24; //ant1 11
		//if (fighter==2) VIP_REGS[GPLT1]=0xa0;
		//if (fighter==3) VIP_REGS[GPLT1]=0xc1; 	
		//if (fighter==4) VIP_REGS[GPLT1]=0xe0;
		if (fighter==9) fighter=1;	
	VIP_REGS[GPLT3]=0xe4;

	if (GoToStart==2){
	vbSetWorld(28, WRLD_ON|1, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|1, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|1, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|1, scroll, -3, scrolly, 0, 0, 0, 384, 224);	
	}


	vbTextOut(0, 15, 2," SELECT FIGHTER ");



	switch (fighter) {
	case 1:
	charcutouty=0, chartotaly=56, neg2=-1, neg=1, fightery=70;	
	copymem((void*)WAVEDATA1, (void*)SINE, 128);	
	copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);	
	vbTextOut(0, 15, 25,"       GI-ANT     ");	
	break;
	
	case 2:
	charcutouty=0, chartotaly=56, neg2=-1, neg=1, fightery=70;	
	copymem((void*)WAVEDATA1, (void*)PIANO,128);	
	copymem((void*)WAVEDATA2, (void*)SINE, 128);	
	vbTextOut(0, 15, 25,"     BEHE-MOTH    ");
	break;
	
	case 3:
	copymem((void*)WAVEDATA1, (void*)VIOLIN, 128);	
	copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);		
	vbTextOut(0, 15, 25,"     RUMBLEBEE    ");
	break;
	
	case 4:
    vbTextOut(0, 15, 25,"    MELEE-DYBUG   ");
	break;
	
	case 5:
	vbTextOut(0, 15, 25,"      SUPERFLY    ");
	break;	
	
	case 6:
	vbTextOut(0, 15, 25,"    KILLIPEDE   ");
	break;
	
	case 7:
	vbTextOut(0, 15, 25,"PANZER DRAGONFLY");
	break;
	
	case 8:
	vbTextOut(0, 15, 25," SLAYING MANTIS ");
	break;	
	
	default:
	break;
	}
	
	//old x positions, 89, 137, 185, 233
	//old y pos - 1, 47
	
	//newer x positions 41, 125, 200, 267
	//newer y positions - 1, 66
	
	//if(vbReadPad()&K_LR) r=1;
	//if ((!(vbReadPad()&K_LR)) && (r==1)) r=1;
	//if (r==1) fighterx=fighterx+8;
	//if (fighterx>384) StopAllSounds(), fighterx=0, fighter++;

	if(vbReadPad()&K_SEL) l=1;
	if ((!(vbReadPad()&K_SEL)) && (l==1)) l=1;
	if (l==1) fighterxsight=fighterxsight-2;
	if (fighterxsight<-132) StopAllSounds(), fighterxsight=384;

	//fightery, xbeginning, ?, ybeginning, totalx, totaly

	vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, 0, 0, 0, 104, 54);	// front
	vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 312, 0, 0, 104, 54); // body	
	vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, 0, 0, 54, 104, 54);	// back



	//vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back


	DoSounds();


	// just temporary code, will change once I get more fighters in here.
	//if (opponent==3) opponent=1;
	if (fighterxsight==140) r=0, l=0;

	
	if (scrolltimer>20) 
	{
	scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	}
	
	
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;		
	
	if((vbReadPad()&K_STA) && (l==0) && (r==0)) StartGame=1;
	if((!(vbReadPad()&K_STA)) && (StartGame==1)) StartGame=2, fighterxsight=140, opponent=fighter-1;
	
	switch (fighter) {
	case 1:
	PlaySound(giant);	
	PlaySound(giantbass);	
	break;
	
	case 2:
	PlaySound(behemoth);	
	PlaySound(behemothbass);		
	break;	
	
	case 3:
	PlaySound(rumblemenu);	
	break;		
	
	case 4:
	PlaySound(meleedybug);	
	PlaySound(meleedybugbass);		
	break;	
	
	case 5:	
	PlaySound(superflylowernotes);	
	PlaySound(superflyuppernotes);			
	break;		
	
	case 6:
	PlaySound(killipedeuppernotes);
	PlaySound(killipedelowernotes);
	break;	
	
	case 7:
	PlaySound(panzeruppernotes);
	PlaySound(panzerlowernotes);
	break;	
	
	case 8:
	PlaySound(mantisuppernotes);
	PlaySound(mantislowernotes);
	break;		
	
	default:
	break;
	
	}

	
	if (fighterxsight==-132) {
	fighter++;
	
	switch (fighter) {
	case 1:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	break;
	
	case 2:
	copymem((void*)CharSeg2, (void*)BEHEMOTHCHAR67, 512*16);
	copymem((void*)BGMap(2), (void*)BEHEMOTHMAP67, 512*16);	
	break;	
	
	case 3:
	copymem((void*)CharSeg2, (void*)RUMBLEBEECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)RUMBLEBEEMAP, 512*16);	
	break;		
	
	case 4:
	copymem((void*)CharSeg2, (void*)MELEEDYBUGCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MELEEDYBUGMAP, 512*16);	
	break;		
	
	case 5:
	copymem((void*)CharSeg2, (void*)SUPERFLYCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)SUPERFLYMAP, 512*16);	
	break;				
	
	case 6:
	copymem((void*)CharSeg2, (void*)KILLIPEDECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)KILLIPEDEMAP, 512*16);	
	break;		

	case 7:
	copymem((void*)CharSeg2, (void*)PANZERCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)PANZERMAP, 512*16);	
	break;		
	
	case 8:
	copymem((void*)CharSeg2, (void*)MANTISCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MANTISMAP, 512*16);	
	break;			
	
	default:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	break;	
	
	}
	
	
	}
	
	opponent=fighter+1;
	
	chartotaly=52;
	
	if (opponent==0) opponent=8;

	VIP_REGS[GPLT0]=0x24;
	VIP_REGS[GPLT1]=0x24; //ant1 11	
	
		//if (fighter==1) VIP_REGS[GPLT1]=0xc1; //ant1 11
		//if (fighter==2) VIP_REGS[GPLT1]=0xa0;	
		//if (fighter==3) VIP_REGS[GPLT1]=0xc1; //ant1 11
		//if (fighter==4) VIP_REGS[GPLT1]=0xe0; //ant1 11	
	
	VIP_REGS[GPLT3]=0xe4;
	
		}

	switch (opponent) {
	case 1:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	break;
	
	case 2:
	copymem((void*)CharSeg2, (void*)BEHEMOTHCHAR67, 512*16);
	copymem((void*)BGMap(2), (void*)BEHEMOTHMAP67, 512*16);		
	break;	

	case 3:
	copymem((void*)CharSeg2, (void*)RUMBLEBEECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)RUMBLEBEEMAP, 512*16);	
	break;		
	
	case 4:
	copymem((void*)CharSeg2, (void*)MELEEDYBUGCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MELEEDYBUGMAP, 512*16);	
	break;	

	case 5:
	copymem((void*)CharSeg2, (void*)SUPERFLYCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)SUPERFLYMAP, 512*16);	
	break;			
	
	case 6:
	copymem((void*)CharSeg2, (void*)KILLIPEDECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)KILLIPEDEMAP, 512*16);	
	break;		
	
	case 7:
	copymem((void*)CharSeg2, (void*)PANZERCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)PANZERMAP, 512*16);	
	break;			
	
	case 8:
	copymem((void*)CharSeg2, (void*)MANTISCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MANTISMAP, 512*16);	
	break;			
	
	default:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	break;	
	
	}
	
	//opponent=fighter+1;
	
	 //if ((opponent==0) && (fighter==1)) opponent=2;
	 //if ((opponent==0) && (fighter==3)) opponent=1;

	 //if (fighter==1)) opponent=2;
	 //if ((opponent>3) && (fighter==2)) opponent=1;
	//copymem ((void*)CharSeg3, (void*)LHFONT, 8192);	
	
	vbTextOut(0, 15, 2," SELECT OPPONENT");	
	
	
	
	
	//copymem((void*)CharSeg0, (void*)CPU2CHAR, 512*16);
	//copymem((void*)BGMap(0), (void*)CPU2MAP, 512*16);	
	
	copymem((void*)CharSeg1, (void*)WALLPAPER14CHAR, 512*16);
	copymem((void*)BGMap(1), (void*)WALLPAPER14MAP, 512*16);

	//copymem((void*)CharSeg2, (void*)GIANTCRAWLPART1BCHAR, 512*16);
	//copymem((void*)BGMap(2), (void*)GIANTCRAWLPART1BMAP, 512*16);	

	StopAllSounds();
	
	
	currNote--;
	// opponent=fighter+1;
	StartGame=0;




	while(StartGame<2){
	
    //SND_REGS[2].SxINT = 0x00;
    //SND_REGS[3].SxINT = 0x00;
	
	scrolltimer=scrolltimer+1;
		if (opponent>8) opponent=1;
	//vbSetWorld(24, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);


	

	vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, 0, 0, 0, 104, chartotaly);	// front
	vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 312, 0, 0, 104, chartotaly); // body	
	vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, 0, 0, 54, 104, chartotaly);	// back

	//vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back




	if (GoToStart==2) {
	vbSetWorld(28, WRLD_ON|1, scroll3, -3, scroll3y, 0, 0, 0, 384, 224);
	vbSetWorld(29, WRLD_ON|1, scroll4, -3, scroll4y, 0, 0, 0, 384, 224);		
	vbSetWorld(30, WRLD_ON|1, scroll2, -3, scroll2y, 0, 0, 0, 384, 224);
	vbSetWorld(31, WRLD_ON|1, scroll, -3, scrolly, 0, 0, 0, 384, 224);	
	
	}


	SongTick++;	




	switch (opponent) {

	case 1:
	//charcutouty=0, chartotaly=56, neg2=-1, neg=1, fightery=70;	
	copymem((void*)WAVEDATA1, (void*)SINE, 128);	
	copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);	
	vbTextOut(0, 15, 25,"      GI-ANT    ");	
	break;
	
	case 2:
	//charcutouty=0, chartotaly=56, neg2=-1, neg=1, fightery=70;	
	copymem((void*)WAVEDATA1, (void*)PIANO,128);	
	copymem((void*)WAVEDATA2, (void*)SINE, 128);	
	vbTextOut(0, 15, 25,"    BEHE-MOTH   ");
	break;
	
	case 3:
	copymem((void*)WAVEDATA1, (void*)VIOLIN, 128);	
	copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);		
	vbTextOut(0, 15, 25,"    RUMBLEBEE   ");
	break;
	
	case 4:
    vbTextOut(0, 15, 25,"   MELEE-DYBUG  ");
	break;
	
	case 5:
	vbTextOut(0, 15, 25,"    SUPERFLY    ");
	break;	

	case 6:
	vbTextOut(0, 15, 25,"    KILLIPEDE   ");
	break;

	case 7:
	vbTextOut(0, 15, 25,"PANZER DRAGONFLY");
	break;
	
	case 8:
	vbTextOut(0, 15, 25," SLAYING MANTIS ");
	break;	
	
	default:
	break;
	}
	
	
	
		//if (opponent==1) VIP_REGS[GPLT1]=0xc1; //ant1 11
		//if (opponent==2) VIP_REGS[GPLT1]=0xa0;
		//if (opponent==3) VIP_REGS[GPLT1]=0xc1; //ant1 11		
		//if (opponent==4) VIP_REGS[GPLT1]=0xd0;
	
	//old x positions, 89, 137, 185, 233
	//old y pos - 1, 47
	
	//newer x positions 41, 125, 200, 267
	//newer y positions - 1, 66
	
	//if(vbReadPad()&K_SEL) r=1;
	//if ((!(vbReadPad()&K_LR)) && (r==1)) r=1;
	//if (r==1) fighterx=fighterx+8;
	//if (fighterx>384) StopAllSounds(), fighterx=0, opponent++;

	if(vbReadPad()&K_SEL) l=1;
	if ((!(vbReadPad()&K_SEL)) && (l==1)) l=1;
	if (l==1) fighterxsight=fighterxsight-2;
	if (fighterxsight<-132) StopAllSounds(), fighterxsight=384;
	
	//if (opponent==0) opponent=3;	
	//if (fighter==1) opponent=1;		
	//if (opponent>3) opponent=1;	

		
	//if ((opponent==fighter) && (r==1)) opponent++;


	 //if (opponent==0) opponent=3;



	//AGAIN, JUST TEMPORARY CODE, WILL CHANGE ONCE I GET MORE FIGHTERS.


	if (fighterxsight==140) r=0, l=0;

	//if (opponent==1) copymem((void*)CharSeg2, (void*)GIANTCRAWL1CHAR, 512*16);
	//if (opponent==1) copymem((void*)BGMap(2), (void*)GIANTCRAWL1MAP, 512*16);	
	
	if (scrolltimer>20) {
	scroll=scroll+1, scroll2=scroll2+1, scroll3=scroll3+1, scroll4=scroll4+1;
	scrolly=scrolly-1, scroll2y=scroll2y-1, scroll3y=scroll3y-1, scroll4y=scroll4y-1, scrolltimer=0;
	}
	
	if (scroll>-41) scroll=-192, scrolly=0, scroll2=112, scroll2y=-16, scroll3=-192, scroll3y=224, scroll4=112, scroll4y=208;		
	
	if((vbReadPad()&K_STA) && (l==0) && (r==0)) StartGame=1;
	if((!(vbReadPad()&K_STA)) && (StartGame==1)) StartGame=2, GoToStart=1, fighterxsight=140, StopAllSounds();
	
	switch (opponent) {
	case 1:
	PlaySound(giant);	
	PlaySound(giantbass);
	break;
	
	case 2:
	PlaySound(behemoth);	
	PlaySound(behemothbass);		
	break;	
	
	case 3:
	PlaySound(rumblemenu);	
	break;		
	
	case 4:
	PlaySound(meleedybug);	
	PlaySound(meleedybugbass);		
	break;	
	
	case 5:	
	PlaySound(superflylowernotes);	
	PlaySound(superflyuppernotes);			
	break;		
	
	case 6:
	PlaySound(killipedeuppernotes);
	PlaySound(killipedelowernotes);
	break;
	
	case 7:
	PlaySound(panzeruppernotes);
	PlaySound(panzerlowernotes);
	break;	
	
	case 8:
	PlaySound(mantisuppernotes);
	PlaySound(mantislowernotes);
	break;		
	
	default:
	break;
	
	}	
	
	DoSounds();

	
	


	
	if (fighterxsight==-132) {
	opponent++;
	if (opponent>8) opponent=1;	
	if (opponent==fighter) opponent++;	

	
	switch (opponent) {
	case 1:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	//ChangeCharsegOfBGMap(1, 1);
	break;
	
	case 2:
	copymem((void*)CharSeg2, (void*)BEHEMOTHCHAR67, 512*16);
	copymem((void*)BGMap(2), (void*)BEHEMOTHMAP67, 512*16);		
	//ChangeCharsegOfBGMap(1, 1);	
	break;	
	
	case 3:
	copymem((void*)CharSeg2, (void*)RUMBLEBEECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)RUMBLEBEEMAP, 512*16);	
	//ChangeCharsegOfBGMap(1, 1);	
	break;		
	
	case 4:
	copymem((void*)CharSeg2, (void*)MELEEDYBUGCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MELEEDYBUGMAP, 512*16);	
	break;	
	
	case 5:
	copymem((void*)CharSeg2, (void*)SUPERFLYCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)SUPERFLYMAP, 512*16);	
	break;		

	case 6:
	copymem((void*)CharSeg2, (void*)KILLIPEDECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)KILLIPEDEMAP, 512*16);	
	break;				
	
	case 7:
	copymem((void*)CharSeg2, (void*)PANZERCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)PANZERMAP, 512*16);	
	break;			
	
	case 8:
	copymem((void*)CharSeg2, (void*)MANTISCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MANTISMAP, 512*16);	
	break;			
	
	default:
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	break;	
	
	}


	
	
	}	
		}

	vbFXFadeOut(2);
	

	
	vbSetWorld(24, WRLD_ON|1, opponentxsight, 1, opponenty+10, 0, 0, 0, 104, 54);	// front
	vbSetWorld(25, WRLD_ON|1, opponentxsight, 0, opponenty, 312, 0, 0, 104, 54);	     // body		
	vbSetWorld(26, WRLD_ON|1, opponentxsight, -1, opponenty+10, 104, 0, 0, 104, 54);	// back
	


	
	
	





	GetRidofIcky=1;
  	GoToStart=1;	





	
	

 
	//vbSetWorld(28, WRLD_ON, bgscroll+364, 0, 0, 0, 0, 224, 384, 224);  

	if (fighter==1)
	{
	copymem((void*)CharSeg2, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)NEWGIANTFINALMAP, 512*16);	
	}
	
	if (fighter==2)
	{
	copymem((void*)CharSeg2, (void*)BEHEMOTHCHAR67, 512*16);
	copymem((void*)BGMap(2), (void*)BEHEMOTHMAP67, 512*16);		
	}
		
	if (fighter==3)
	{
	copymem((void*)CharSeg2, (void*)RUMBLEBEECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)RUMBLEBEEMAP, 512*16);	
	//ChangeCharsegOfBGMap(1, 1);	
	}		
		
	if (fighter==4){
	copymem((void*)CharSeg2, (void*)MELEEDYBUGCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MELEEDYBUGMAP, 512*16);	
	}			

	if (fighter==5){
	copymem((void*)CharSeg2, (void*)SUPERFLYCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)SUPERFLYMAP, 512*16);	
	}	

	if (fighter==6){
	copymem((void*)CharSeg2, (void*)KILLIPEDECHAR, 512*16);
	copymem((void*)BGMap(2), (void*)KILLIPEDEMAP, 512*16);	
	}				
	
	if (fighter==7){
	copymem((void*)CharSeg2, (void*)PANZERCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)PANZERMAP, 512*16);	
	}
	
	if (fighter==8){
	copymem((void*)CharSeg2, (void*)MANTISCHAR, 512*16);
	copymem((void*)BGMap(2), (void*)MANTISMAP, 512*16);	
	}	
	
	vbSetWorld(24, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(25, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(26, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);		
	
	vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// front
	vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back
	vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	     // body	
		
	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);			
		
		
  //SND_REGS[1].SxINT = 0x00;
  //SND_REGS[2].SxINT = 0x00;

		VIP_REGS[GPLT0]=0xe4;
	VIP_REGS[GPLT1]=0x24; //ant1 11	
	
		VIP_REGS[GPLT2]=0xE4; // foreground	
		VIP_REGS[GPLT3]=0xe4; // background

     	//VIP_REGS[GPLT0]=0xb4; // background
		
		
	//vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0); // make cursor go off

	
	//vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);


	
	//init_speech(); //initialize sound regs for speech




	
	//vbSetWorld(20, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);	

	

	

	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up
	//while (!(VIP_REGS[XPSTTS] & XPBSY1)); // makes sure to freeze screen on framebuffer 0
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] & ~XPEN; // turn off screen refreshing so once a dot is drawn it stays there until refreshed again (start pressed)	

	//opponent=1, fighter=1;	// temporary code, delete when more than one fighter is designed!
		
	

		
	//ChangeCharsegOfBGMap(1, 1);
	

	
	//DID YOU REMEMBER TO PRESS THE OK BUTTON WHEN MAKING A GPLT>0??????
	
	//FIGHTER=BGMap2
	//OPPONENT=BGMap1
	
	//levels
	//31 - background left eye scrolling
	//30 - background right eye scrolling
	//29 - 
	//28 - foreground scrolling
	//27 - foreground scrolling continuted
	//26 - opponent part 1
	//25 - opponent part 2
	//24 - opponent part 3
	//23 - fighter part 1
	//22 - fighter part 2
	//21 - fighter part 3

	charcutouty=1, charcutouty2=56, charcutoutx=0, charcutoutx2=0, totalx1=104, totalx2=104;
	bgscroll=0, opponentxsight=200, opponentmovedir=1, opponentx=200, opponenty=156; 
	bgbgscrolltimer=0, bgbgscroll=0, bgtopscroll=0, fighterx=10, fightery=156, fighterxsight=10, left=0, right=1;


	//vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	//vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// front
	//vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back
	//vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	     // body
	




	//vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	//vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);  
	//vbSetWorld(28, WRLD_ON, 364, 0, 0, 0, 20, 224, 384, 224);  
	
	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, charcutoutx, 0, charcutouty, 104, 56);	// front
	//vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 312, 0, 0, 104, 56); // body	
	//vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, charcutoutx2, 0, charcutouty2, 104, 56);	// back
	
	//vbSetWorld(24, WRLD_ON|2, fighterxsight, neg, fightery+10, charcutoutx2, 0, charcutouty2, 0, 0);	// back	
	
	//vbSetWorld(24, WRLD_ON|1, opponentxsight, 1, 142, 0, 0, 0, 100, 148);	// front
	//vbSetWorld(26, WRLD_ON|1, opponentxsight, -1, 142, 100, 0, 0, 98, 148);	// back
	//vbSetWorld(25, WRLD_ON|1, opponentxsight, 0, 142, 200, 0, 0, 102, 148);	     // body	


	//vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery, 160, 0, 0, 160, 148);	// back
	//vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 320, 0, 0, 160, 148);	     // body	
	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery, 0, 0, 0, 160, 148);	// front	
	
	//vbSetWorld(24, WRLD_ON|2, opponentxsight, 1, opponenty, 0, 0, 0, 160, 148);	// front
	//vbSetWorld(25, WRLD_ON|2, opponentxsight, 0, opponenty, 320, 0, 0, 160, 148);	     // body		
	//vbSetWorld(26, WRLD_ON|2, opponentxsight, -1, opponenty, 160, 0, 0, 160, 148);	// back
	//ChangeCharSegOfBGMap (2, 1);
	
	
	//fighter=ant then CharSeg(2)
	//opponent=ant then CharSeg(1) - isn't implemented yet.
	
	//fighter=ant then GPLT1

	//copymem((void*)CharSeg3, (void*)ICFONT, 8192);	

	//SND_REGS[1].SxINT = 0x80;
	//SND_REGS[2].SxINT = 0x80;

	//copymem((void*)WAVEDATA1, (void*)PIANO, 128);	
	//copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);


	//vbSetWorld(22, WRLD_ON|2, fighterxsight, neg, fightery, 320, 0, 0, 160, 148);	     // body
		

	left=0;
	animframe2=1, animframe3=1;
	//currBassNote=-1;
	//SongTick=1;
	//SongTick2=4;
	//if (fighter==1) SongTick2=8;
	logoy=182;
	//currNoteLength=0;
	turning=0;
	fight=1;
	paused=0;
	
	

	
	
	
	
	fall=0, falltimer=0;
	//copymem((void*)CharSeg1, (void*)GIANTCRAWLPART1BCHAR, 512*16);
	//copymem((void*)BGMap(1), (void*)GIANTCRAWLPART1BMAP, 512*16);

	
	//copymem((void*)CharSeg2, (void*)GIANTCRAWLPART1BCHAR, 512*16);
	//copymem((void*)BGMap(2), (void*)GIANTCRAWLPART1BMAP, 512*16);	
	
	//whichmap=3;
	//if (fighter==1) whichmap=0;
	
	//copymem((void*)CharSeg2, (void*)GIANTCRAWLPART1ACHAR, 512*16);
	//copymem((void*)BGMap(2), (void*)GIANTCRAWLPART1AMAP, 512*16);			
	
	//ChangeCharsegOfBGMap(1, 2);		
	
	//instrument1=3;
	
	//copymem((void*)CharSeg3, (void*)ICFONT, 8192);	
	
	switch (fighter) {
	
	
	
	
	case 1:
	vbTextOut(3, 1, 0,"GI-ANT               ");
	break;
	
	case 2:
	vbTextOut(3, 1, 0,"BEHE-MOTH            ");
	break;
	
	case 3:
	vbTextOut(3, 1, 0,"RUMBLEBEE            ");
	break;
	
	case 4:
	vbTextOut(3, 1, 0,"MELEE-DYBUG          ");
	break;
	
	case 5:
	vbTextOut(3, 1, 0,"SUPERFLY             ");	
	break;	
	
	case 6:
	vbTextOut(3, 1, 0,"KILLIPEDE            ");
	break;
	
	case 7:
	vbTextOut(3, 1, 0,"PANZER DRAGONFLY     ");
	break;
	
	case 8:
	vbTextOut(3, 1, 0,"SLAYING MANTIS       ");
	break;	
	
	default:
	break;
	}
	
	
	switch (opponent) {
	
	case 1:
	vbTextOut(3, 26, 0,"               GI-ANT  ");
	break;
	
	case 2:
	vbTextOut(3, 26, 0,"            BEHE-MOTH  ");
	break;
	
	case 3:
	vbTextOut(3, 26, 0,"            RUMBLEBEE  ");
	break;
		
	case 4:
	vbTextOut(3, 26, 0,"          MELEE-DYBUG  ");
	break;

	case 5:
	vbTextOut(3, 26, 0,"             SUPERFLY  ");
	break;
	
	case 6:
	vbTextOut(3, 26, 0,"            KILLIPEDE  ");
	break;
	
	case 7:
	vbTextOut(3, 26, 0,"     PANZER DRAGONFLY  ");
	break;
	
	case 8:
	vbTextOut(3, 26, 0,"       SLAYING MANTIS  ");
	break;	
	
	default:
	break;
	
	
	}
	vbTextOut(3, 0, 1," QQQQQQQQQQQQQQQQ");
	vbTextOut(3, 31, 1,"QQQQQQQQQQQQQQQQ");	
	StopAllSounds();

	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up



	vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(30, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	vbSetWorld(28, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	//vbSetWorld(21, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// front
	//vbSetWorld(23, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	// back
	//vbSetWorld(22, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);	     // body

	//vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	

	//vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	
	vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);
	vbSetWorld(24, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(25, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	vbSetWorld(26, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	//vbSetWorld(19, WRLD_ON|3, bgtopscroll+384, 2, 0, 0, 0, 224, 384, 224);


	//if (animwait>3) 
	//animwait=0, animframe2++;

	vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, charcutoutx, 0, charcutouty, 104, 54);	// front
	vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 312, 0, 0, 103, 54); // body	
	vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, charcutoutx2, 0, charcutouty2, 104, 54);	// back


	vbSetWorld(24, WRLD_ON|1, opponentxsight, 1, opponenty+10, 0, 0, 0, 104, 54);	// front
	vbSetWorld(25, WRLD_ON|1, opponentxsight, 0, opponenty, 312, 0, 0, 104, 54);	     // body		
	vbSetWorld(26, WRLD_ON|1, opponentxsight, -1, opponenty+10, 0, 0, 54, 104, 54);	// back


	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery, 0, 0, charcutouty, 100, chartotaly);	// front
	//vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 202, 0, charcutouty, 108, chartotaly); // body	
	//vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery, 100, 0, charcutouty, 100, chartotaly);	// back
	vbSetWorld(19, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 12);	

	bgmovey=410, bgmovex=0;


	vbSetWorld(30, WRLD_ON, 0, 0, 0, 0, 0, 0, 404, 224);  
	//vbSetWorld(28, WRLD_ON|3, bgbgscroll, -2, 0, 0, 0, 0, 384, 224);	
	//if (fighter==1) vbSetWorld(27, WRLD_ON, bgtopscroll, 2, 0, 0, 0, 224, 508, 224);
	//if (fighter==2) vbSetWorld(27, WRLD_ON, bgtopscroll, 2, 0, 0, 0, 224, 508, 224);
	//if (fighter==3) vbSetWorld(20, WRLD_ON, bgtopscroll, 2, 0, 0, 0, 224, 508, 224);
	//if (fighter==4) vbSetWorld(27, WRLD_ON, bgtopscroll, 2, 0, 0, 0, 224, 508, 224);	

	vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);

	if (opponent==1){
	copymem((void*)CharSeg1, (void*)NEWGIANTFINALCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)NEWGIANTFINALMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);
	}
	
	if (opponent==2){
	copymem((void*)CharSeg1, (void*)BEHEMOTHCHAR67, 512*16);
	copymem((void*)BGMap(1), (void*)BEHEMOTHMAP67, 512*16);		
	ChangeCharsegOfBGMap(1, 1);	
	}

	if (opponent==3){
	copymem((void*)CharSeg1, (void*)RUMBLEBEECHAR, 512*16);
	copymem((void*)BGMap(1), (void*)RUMBLEBEEMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);	
	}	
	
	if (opponent==4){
	copymem((void*)CharSeg1, (void*)MELEEDYBUGCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)MELEEDYBUGMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);
	}		


	if (opponent==5){
	copymem((void*)CharSeg1, (void*)SUPERFLYCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)SUPERFLYMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);	
	}	

	if (opponent==6){
	copymem((void*)CharSeg1, (void*)KILLIPEDECHAR, 512*16);
	copymem((void*)BGMap(1), (void*)KILLIPEDEMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);	
	}	

	if (opponent==7){
	copymem((void*)CharSeg1, (void*)PANZERCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)PANZERMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);	
	}	
	
	if (opponent==8){
	copymem((void*)CharSeg1, (void*)MANTISCHAR, 512*16);
	copymem((void*)BGMap(1), (void*)MANTISMAP, 512*16);	
	ChangeCharsegOfBGMap(1, 1);	
	}		
	
	
	if (fighter==1){
	copymem((void*)CharSeg0, (void*)GIANTBGCHAR7, 512*16);
	copymem((void*)BGMap(0), (void*)GIANTBGMAP7, 512*16);	
	VIP_REGS[GPLT0]=0xe4; 	
	}

	if (fighter==2){
	copymem((void*)CharSeg0, (void*)BEHEMOTHBGCHAR2, 512*16);
	copymem((void*)BGMap(0), (void*)BEHEMOTHBGMAP2, 512*16);	
	VIP_REGS[GPLT0]=0xb4; 	
	}
	
	if (fighter==3){
	copymem((void*)CharSeg0, (void*)RUMBLEBEEBGCHAR3, 512*16);
	copymem((void*)BGMap(0), (void*)RUMBLEBEEBGMAP3, 512*16);	
	VIP_REGS[GPLT0]=0xe4; 	
	}

	if (fighter==4){
	copymem((void*)CharSeg0, (void*)MELEEDYBUGBGCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)MELEEDYBUGBGMAP, 512*16);	
	VIP_REGS[GPLT0]=0xb4; // background
	}

	if (fighter==5){
	copymem((void*)CharSeg0, (void*)SUPERFLYBGCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)SUPERFLYBGMAP, 512*16);	
	VIP_REGS[GPLT0]=0xe4; // background
	}

	if (fighter==6){
	copymem((void*)CharSeg0, (void*)KILLIPEDEBGCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)KILLIPEDEBGMAP, 512*16);	
	VIP_REGS[GPLT0]=0xb4; // background
	}
	
	if (fighter==7){
	copymem((void*)CharSeg0, (void*)PANZERBGCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)PANZERBGMAP, 512*16);
	//vbSetWorld(15, WRLD_ON, frogxsight, -2, frogy, 0, 0, 480, 40, 32);
	VIP_REGS[GPLT0]=0xb4; // background
	}	
	
	if (fighter==8){
	copymem((void*)CharSeg0, (void*)MANTISBGCHAR, 512*16);
	copymem((void*)BGMap(0), (void*)MANTISBGMAP, 512*16);	
	VIP_REGS[GPLT0]=0xdc; // background  d8
	}	
	
	
	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery, 0, 0, charcutouty, 100, chartotaly);	// front	

		//if (opponent==1) VIP_REGS[GPLT1]=0xc1; //ant1 11
		//if (opponent==2) VIP_REGS[GPLT1]=0xa0;
		//if (opponent==3) VIP_REGS[GPLT1]=0xc1; //ant1 11
		//if (opponent==4) VIP_REGS[GPLT1]=0xe0;

	//bgmove3=224, bgmove=384, bgmove4=224;

	//vbSetWorld(19, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 12);

	//vbSetWorld(18, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 12);		
	//changeback=1;
	
	if(GetRidofIcky==1){
	
	

	
	
	copymem((void*)WAVEDATA1, (void*)VIOLIN, 128);	
	copymem((void*)WAVEDATA2, (void*)VIOLIN, 128);		
	
	
	switch (fighter)
	{
	
	case 1:
	flipheight=37;
	PlaySound(giant);		
	PlaySound(giantbass);	
	break;
	
	case 2:
	flipheight=29;
	PlaySound(behemoth);		
	PlaySound(behemothbass);
	break;
	
	case 3:
	PlaySound(rumblemenu);
	break;
	
	case 4:
	PlaySound(meleedybug);	
	PlaySound(meleedybugbass);		
	break;
	
	case 5:
	PlaySound(superflylowernotes);	
	PlaySound(superflyuppernotes);	
	break;
	
	case 6:
	PlaySound(killipedeuppernotes);
	PlaySound(killipedelowernotes);
	break;
	
	case 7:
	PlaySound(panzeruppernotes);
	PlaySound(panzerlowernotes);
	break;
	
	case 8:
	PlaySound(mantisuppernotes);
	PlaySound(mantislowernotes);
	break;	
	
	default:
	break;
	
	}

	HFlip2(1), HFlip(1);
	vbFXFadeIn(2);	



	opponentleft=0, punch=0;



	StartGame=12;





	while(StartGame==12){
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up
	//e=e+1;	



	
	//ChangeCharsegOfBGMap(1, 1);


	//if(!(vbReadPad()&K_LL) && (left==1)) left=0;


	
		

	
	//if((vbReadPad()&K_LD) && (fightery<124)) fightery=fightery+1; 
	
	//if((vbReadPad()&K_LU) && (fightery>46)) fightery=fightery-1;


	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to refresh the screen
	//while (!(VIP_REGS[XPSTTS] & XPBSY1)); // makes sure to freeze screen on framebuffer 0
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] & ~XPEN; // turn screen refreshing off again
	

	//if (fightery>124) fall=0, jumptimer=11;	
	
	
	//vbSetWorld(31, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(29, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);		
	

	//vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);
	
	//vbSetWorld(27, WRLD_ON|1, 0, 0, 0, 0, 0, 0, 0, 0);	
	//vbSetWorld(26, WRLD_ON|2, 0, 0, 0, 0, 0, 0, 0, 0);		
	
	//vbSetWorld(19, WRLD_ON|3, bgtopscroll+384, 2, 0, 0, 0, 224, 384, 224);


	//if (animwait>3) 
	//animwait=0, animframe2++;


	while(paused>0)
	{
	
	vbTextOut(0, 22, 0,"      "); 
	vbTextOut(3, 22, 0,"PAUSED"); 	
	
	vbSetWorld(30, WRLD_ON, bgscroll, -2, 0, 0, 0, 0, 704, 224);  

	//vbSetWorld(19, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 12);	
	
		//vbSetWorld(30, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);		
	
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up
	//while (!(VIP_REGS[XPSTTS] & XPBSY1)); // makes sure to freeze screen on framebuffer 0
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] & ~XPEN; // turn off screen refreshing so once a dot is drawn it stays there until refreshed again (start pressed)	
	PauseAllSounds();

	if ((vbReadPad()&K_STA) && (paused==1)) paused=2;
	if ((!(vbReadPad()&K_STA)) && (paused==2)) paused=0; 	
	
	if ((vbReadPad()&K_SEL) && (select==0)) select=1;
	if (!(vbReadPad()&K_SEL) && (select==1)) select=0, StartGame=0, StopAllSounds(), main();

	
	//if (fighter==3) vbTextOut(3, 22, 0,"PAUSED");
	}

	if (paused<1)
	{

	vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, charcutoutx, 0, charcutouty, 104, 62);	// front
	vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 312, 0, 0, 104, 62); // body	
	vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, charcutoutx2, 0, charcutouty2, 104, 62);	// back


	vbSetWorld(24, WRLD_ON|1, opponentxsight, 1, opponenty+10, 0, 0, 0, 104, 54);	// front
	vbSetWorld(25, WRLD_ON|1, opponentxsight, 0, opponenty, 312, 0, 0, 104, 54);	     // body		
	vbSetWorld(26, WRLD_ON|1, opponentxsight, -1, opponenty+10, 0, 0, 54, 104, 54);	// back

	opponentyminus=opponenty-10;
	opponentyplus=opponenty+25;
	opponentxminus=opponentxsight-40;
	opponentxplus=opponentxsight+40;

	if (fighter==7)
	{
	
	//frogxsight=300;
	
	vbSetWorld(18, WRLD_ON, frogxsight, -1, frogy, frogxcut, 0, 481, 40, 32);

	if (frogy<140) frogjumptimer++;
	frogtimer++;
	if ((frogwait==0) && (frogtimer>10)) frogtimer=0;
	if (frogup==1) frogxcut=0, frogy--;
	//if ((fighterxsight<283) && (vbReadPad()&K_LR)) frogxsight=frogxsight+1;
	//if ((fighterxsight>10) && (vbReadPad()&K_LL)) frogxsight=frogxsight-1;
	
	if (frogup==2) frogxcut=0, frogy++;
	//if ((frogup==2) && (fighterxsight>283) && (frogwait>0) && (vbReadPad()&K_LR)) frogxsight=frogxsight+1;
	//if ((frogup==2) && (fighterxsight>10) && (frogwait>0) && (vbReadPad()&K_LL)) frogxsight=frogxsight-1;
	
	if (frogy==140) frogup=0, frogxcut=40, frogwait++;
	if (frogjumptimer==65) frogup=2;
	if (frogwait>50) frogjumptimer=0, frogwait=0, frogxcut=0, frogy=139, frogup=1;
	if (frogxsight<-31) frogwait=0, frogtimer=0, frogxsight=488, frogy=140, frogup=1, frogxcut=0, frogjumptimer=64;
	}

	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery, 0, 0, charcutouty, 100, chartotaly);	// front
	//vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 202, 0, charcutouty, 108, chartotaly); // body	
	//vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery, 100, 0, charcutouty, 100, chartotaly);	// back
	
	vbTextOut(3, 22, 0,"      "); 
	vbTextOut(0, 22, 0,"      "); 

	//	vbSetWorld(19, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 384, 12);	
	
		//vbSetWorld(30, WRLD_ON|3, 0, 0, 0, 0, 0, 0, 0, 0);	
	
	//vbSetWorld(28, WRLD_ON|3, bgbgscroll, -2, 0, 0, 0, 0, 384, 224);

	//vbSetWorld(28, WRLD_ON, bgscroll+364, 0, 0, 0, 0, 224, 384, 224);  
	
	//vbSetWorld(18, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 12);	

	//vbSetWorld(30, WRLD_ON, bgscroll, 0, 0, 0, 0, 0, 404, 224);  
	
	//bgmove3=224, bgmove=-192, bgmove4=224;	
	
	
	//vbSetWorld(28, WRLD_ON|3, bgbgscroll, -2, 0, 0, 0, 0, 384, 224);	
	vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);
	//if (fighter==2) vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);
	//if (fighter==3) vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);
	//if (fighter==4) vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);
	//if (fighter==5) vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);
	//if (fighter==6) vbSetWorld(27, WRLD_ON, bgtopscroll, 0, 0, 0, 0, 224, 704, 224);

	vbSetWorld(30, WRLD_ON, bgscroll, -2, 0, 0, 0, 0, 704, 224);  

	DoSounds();
	//if ((left==1) && (fliptheh==2)) HFlip(2);	
    //if ((left==1) && (fliptheh==2)) fliptheh=0;	
	

	
	if((vbReadPad()&K_LU) && (special==0) && (jump==0) && (jumptimer==0) && (punch==0))
	{
	punch=0, jump=1;
	}	

	//PlaySound(fotb);


	if (jump==1) jumptimer2++;
	if (jumptimer2==60) jumptimer2=0, jumptimer++;
	
	
	if((jump==1) && (jumptimer>26)) jump=0, fall=1, jumptimer=0;
	
	if((vbReadPad()&K_B) && (jump==0) && (special==0) && (fighterxsight>opponentxminus) && (fighterxsight<opponentxplus) && (punch==0)) special=2;
	if(!(vbReadPad()&K_B) && (special==2)) special=1;
	
	
	if (special==1)
	{
	
	//special character set down 20 pixels from what it should be.

	if (fighter<3){
	

	if (specialtimer>99) charcutouty=238, charcutoutx=328, totalx1=104;	
	
	
	if ((specialtimer<100) && (fighter<3)) opponenty=fightery-32, opponentxsight=fighterxsight, opponentx=fighterx;	
	if ((specialtimer<100) && (fighter==2) && (opponent==8) && (left==1)) opponenty=fightery-32, opponentxsight=fighterxsight-15, opponentx=fighterx-15;
	if ((specialtimer<100) && (fighter==2) && (opponent==8) && (left==0)) opponenty=fightery-32, opponentxsight=fighterxsight-30, opponentx=fighterx-30;

	
	opponentleft=left;
	
	if(vbReadPad()&K_B) specialtimer=100;	
	
	if ((specialtimer>99) && (left==1) && (opponentx>30) && (opponenty<156)) specialtimer=100, opponentx=opponentx-7, opponentxsight=opponentxsight-7;
	if ((specialtimer>99) && (left==0) && (opponentx<710) && (opponenty<156)) specialtimer=100, opponentx=opponentx+7, opponentxsight=opponentxsight+7;
	
	if ((specialtimer>99) && (opponentxsight<30)) opponentx=opponentx-7;	
	if ((specialtimer>99) && (opponentx<30)) opponentx=30;
	if ((specialtimer>99) && (opponentxsight>283)) opponentx=opponentx+7;
	if ((specialtimer>99) && (opponentx>710)) opponentx=710;
	
	
	if (specialtimer<99){
		
	switch (animframe2){

	case 1:
	charcutouty=238, charcutouty2=56, charcutoutx=0, charcutoutx2=0, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);	
	break;
	
	case 2:
	charcutouty=238, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;	
	//if (left==1) HFlip(2);
	break;		
	
	case 3:
	charcutouty=238, charcutouty2=56, charcutoutx=208, charcutoutx2=208, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);
	break;
	
	case 4:
	charcutouty=238, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);	
	break;
	
	case 5:
	charcutouty=238, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;	
	//if (left==1) HFlip(2);
	break;		
	

	//if ((left==1) && (left2==1)) left2=0, 
 	//octoy, xbeginning, ?, ybeginning, totalx, totaly
	}	
	}


	
	
	if (specialtimer>99) opponenty++;
	
	if (opponenty>155) opponenty=156, specialtimer=0, special=0;
	}

	
	}
	
	

	
	
	
	if((vbReadPad()&K_A) && (jump==0) && (jumptimer==0) && (punch==0))
	{
	punch=1, jump=0;
	}	
	


	if (punch==1) punchtimer2++;
	if ((punch==1) && (punchtimer2>7)) punchtimer2=0, punchtimer++;
	if ((punch==1) && (punchtimer>4)) punch=0, punchtimer=0;
	// ant :
	// fighterpos1 = front legs
	// fighterpos2 = back legs
	// fighterpos3 = body
	
	//vbSetWorld(28, WRLD_ON, 0, 0, 0, 0, 0, 0, 384, 224);

	//if((!(vbReadPad()&K_LL)) && (!(vbReadPad()&K_LR))) animframe2=1;
	//if (animframe2==4) animframe2=0, fliptheh=0;
	//if ((left==1) && (animframe2==1)) fliptheh=2;

	attackopponentx=opponentxsight+50;
	attackopponentxminus=opponentxsight-50;
	

	
	//if ((left==1) && (animframe2>6)) animframe2=1;
	//if ((left==0) && (animframe2>6)) animframe2=1;


	//charcutouty=0, chartotaly=96;			
	}

	//switch (fighter){
	if ((fall==0) && (special==0) && (punch==1) && (jump==0)){
	//changeback=0;
	//DoSounds();	

	switch (punchtimer){
	case 1:
	charcutouty=1, charcutouty2=56, charcutoutx=0, charcutoutx2=0, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);	
	break;
	
	case 2:
	charcutouty=111, charcutouty2=166, charcutoutx=208, charcutoutx2=208, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);
	break;		
	
	case 3:
	charcutouty=111, charcutouty2=166, charcutoutx=312, charcutoutx2=312, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);
	break;
	
	case 4:
	charcutouty=111, charcutouty2=166, charcutoutx=208, charcutoutx2=208, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);
	break;	


	}
	}		

	
	//default:		// used to be case 1:
	
	if ((fall==0) && (special==0) && (punch==0) && (jump==0))
	{

	//DoSounds();
	switch (animframe2){
	
	
	case 1:
	charcutouty=1, charcutouty2=56, charcutoutx=0, charcutoutx2=0, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);	
	break;
	
	case 2:
	charcutouty=1, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;	
	//if (left==1) HFlip(2);
	break;		
	
	case 3:
	charcutouty=1, charcutouty2=56, charcutoutx=208, charcutoutx2=208, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);
	break;
	
	case 4:
	charcutouty=1, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;
	//if (left==1) HFlip(2);	
	break;
	
	case 5:
	charcutouty=1, charcutouty2=56, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;	
	//if (left==1) HFlip(2);
	break;		
	

	//if ((left==1) && (left2==1)) left2=0, 
 	//octoy, xbeginning, ?, ybeginning, totalx, totaly
	}	
	


	

	
	if ((fall==0) && (special==0) && (punch==0) && (jump==1)){
	//fightery, xbeginning, ?, ybeginning, totalx, totaly
	//vbSetWorld(21, WRLD_ON|2, fighterxsight, neg2, fightery+10, charcutoutx, 0, charcutouty, 64, 64);	// front
	//vbSetWorld(22, WRLD_ON|2, fighterxsight, 0, fightery, 264, 0, 0, 100, 64); // body	
	//vbSetWorld(23, WRLD_ON|2, fighterxsight, neg, fightery+10, charcutoutx2, 0, charcutouty2, 64, 64);	// back	
	
	//fliptheh=0;	
	//DoSounds();	
	charcutouty=111, charcutouty2=166, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;
	}
	
	if ((punch==0) && (special==0) && (jump==0) && (fall==1)){

	
	//fliptheh=0;	
	//DoSounds();	
	charcutouty=111, charcutouty2=166, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;
	}
	
	

	}
	
	//stuff goes here.
	
	//default:
	//break;
	
	//WORLD_SET_M(22, 160, 0, 0);
	//WORLD_SET_M(21, 0, 0, 0);
	//WORLD_SET_M
	//}
	

	
 	if (animframe3==5) animframe3=1;
	

	
	

	

	//if((punch==1) && (punchtimer<5)) punch=1;
		
	
	//if ((left==1) && (fliptheh==0)) HFlip(2), fliptheh=1;



	if (fall==1) {

	//fliptheh==0;

	fightery=fightery+4;



	if (fightery<137)
	{
	charcutouty=111, charcutouty2=166, charcutoutx=104, charcutoutx2=104, totalx1=104, totalx2=104;	
	} else
	{
	fall=0, jumptimer=0, fightery=156, changeback=1;	
	charcutouty=0, chartotaly=67;
	}


	//if ((fall==1) && (fightery<65)) 


	}


	if ((jump==1) && (jumptimer<29)) {
	jumptimer++;
	if ((jumptimer>1) && (jumptimer<28)) fightery=fightery-4;	
	//if (jumptimer==1) fightery=fightery+16; 
	} 
	
	
	if ((jump==1) && (jumptimer>28)) {	
	jumptimer=0, jump=0, fall=1, changeback=0; 
	}

	
	if ((punch==1) && (punchtimer>4)) punch=0, punchtimer=0, fliptheh=0, changeback=1;
	
	

	
	if (changeback==1) {
	
	punchtimer=0, jumptimer=0;

	punch=0, jump=0;
	
	

	
	//if (left==1) HFlip(2); 
	charcutouty=0, chartotaly=96;
	changeback=0;
	//animframe2=1;
	}	
		
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] | XPEN; // sets the XPEN bit to make sure Etch-A-Sketch board shows up
	//while (!(VIP_REGS[XPSTTS] & XPBSY1)); // makes sure to freeze screen on framebuffer 0
	//VIP_REGS[XPCTRL] = VIP_REGS[XPSTTS] & ~XPEN; // turn off screen refreshing so once a dot is drawn it stays there until refreshed again (start pressed)		
		
		
	if (changeback==1){
	jumptimer=0;
	punch=0;
	if ((left==1) && (fliptheh==0)) {HFlip2(2), HFlip(2), fliptheh=1; }
	punchtimer=0;
	changeback=0;
	animframe2=1;
	}			
	
	if ((changeback==1) && ((vbReadPad()&K_LU))) {
	punchtimer=0, jumptimer=6;
	jump=0, fall=1;
	if ((left==1) && (fliptheh==0)) {HFlip2(2), HFlip(2), fliptheh=1; }

	changeback=0;
	animframe2=1;
	}		
	
		
	//if ((vbReadPad()&K_LR) && (punch==0) && (jump==0) && (fall==0) && (fliptheh==1)) HFlip(2), fliptheh=0, left=0;
	//if ((vbReadPad()&K_LL) && (punch==0) && (jump==0) && (fall==0) && (fliptheh==0)) HFlip(2), fliptheh=1, left=1;

	//if (!(vbReadPad()&K_LL) && (left==1)) left=1;

	//ChangeCharsegOfBGMap(1, 1);
	


	DoSounds();
	
	DoSounds();	
	
 	//octoy, xbeginning, ?, ybeginning, totalx, totaly
	




	

	if((!(vbReadPad()&K_LU)) && (jump==1)) jump=0, fall=1;
	
	
	if ((fall==1) && (fightery<122)) jumptimer=1;

	


	//if((!(vbReadPad()&K_A)) && (punch==1)) punch=1;
	


	//if (((!(vbReadPad()&K_LR))) && (!(vbReadPad()&K_LL) && (left==1))) left=1;

	if ((vbReadPad()&K_LR) && (right==0)) left=0, right=1, HFlip2(2), HFlip(2); 
	if ((vbReadPad()&K_LR) && (fighterx<704)) animframe2++, fighterx=fighterx+4;
	if ((vbReadPad()&K_LR) && (fighterxsight<284)) fighterxsight=fighterxsight+4;
	if ((vbReadPad()&K_LR) && (fighterxsight>283) && (bgtopscroll>-284)) fighterxsight=284, bgtopscroll=bgtopscroll-4, bgscroll--, opponentxsight=opponentxsight-4;
	if ((vbReadPad()&K_LR) && (fighterxsight>283) && (bgtopscroll>-284) && (fighter==7)) frogxsight--;
	//if ((vbReadPad()&K_LR) && (frogxsight>3) && (fighter==7)) frogxsight=frogxsight-4;	
	//if ((vbReadPad()&K_LR) && (fighterx>283)) 
	//if ((vbReadPad()&K_LR) && (frogxsight>-32) && (frogjumptimer>0) && (fighter==7)) frogxsight--; 
	
	
	if ((vbReadPad()&K_LL) && (left==0)) left=1, right=0, HFlip2(2), HFlip(2);
	if ((vbReadPad()&K_LL) && (fighterx>10)) animframe2++, fighterx=fighterx-4; 
	if ((vbReadPad()&K_LL) && (fighterxsight>10)) fighterxsight=fighterxsight-4;
	if ((vbReadPad()&K_LL) && (fighterxsight<10) && (bgtopscroll<0)) fighterxsight=11, bgtopscroll=bgtopscroll+4, bgscroll++, opponentxsight=opponentxsight+4, frogxsight++;
	//if ((vbReadPad()&K_LL) && (fighterxsight<10) && (bgtopscroll<0) && (fighter==7)) 
	
	
	//if ((vbReadPad()&K_LL) && (frogxsight<488) && (frogjumptimer>0) && (fighter==7)) frogxsight++;

	//if ((vbReadPad()&K_LL) && (fighter==7)) frogxsight=frogxsight+4;

	if (left==0) neg=1, neg2=-1; //fliptheh=0;
	if (left==1) neg=-1, neg2=1;

	if (animframe2>5) animframe2=1;

	if ((special==1) && (opponentleft==1) && (opponentflip==0)) opponentflip=1, HFlip2(1), HFlip(1);
	if ((special==1) && (opponentleft==0) && (opponentflip==1)) opponentflip=0, HFlip2(1), HFlip(1);



	if ((special==0) && (opponentx>fighterx) && (opponentflip==0)) opponentflip=1, HFlip2(1), HFlip(1);
	if ((special==0) && (opponentx<=fighterx) && (opponentflip==1)) opponentflip=0, HFlip2(1), HFlip(1);


	//if ((opponentleft==0) && (opponentflip==0)) opponentflip=1, HFlip2(1), HFlip(1);


	
	if ((vbReadPad()&K_LR) && (bgbgscrolltimer>3)) left=0, bgbgscrolltimer=0, bgbgscroll--;
	if ((vbReadPad()&K_LL) && (bgbgscrolltimer>3)) left=1, bgbgscrolltimer=0, bgbgscroll++;

	if ((vbReadPad()&K_STA) && (paused==0)) paused=-1;
	if ((!(vbReadPad()&K_STA)) && (paused==-1)) paused=1, vbTextOut(0, 22, 0,"PAUSED");	




	//if (fighter==3) vbTextOut(3, 22, 0,"      "); 
	}


	
	//DoSounds();

	}
	
	}
	
	//}
	
//}
